package com.blazinggames.gamejam.converse.starling
{
	import flash.utils.getTimer;
	
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.events.EventDispatcher;
	import starling.text.TextField;
	
	public class AnimatedText extends EventDispatcher
	{
// ***** CONSTANTS *****
		
		public static const STRING_FINISHED_EVENT:String = "StringFinished";
		
		public static const SLOWTEXT:int = 0;
		public static const EXPLODINGTEXT:int = 1;
		
// ***** VARIABLES *****
		
		public var messageText:String;
		public var charsPerSecond:Number;
		public var outputTextField:TextField;
		public var animationMode:int;
		
		protected var curPosition:Number;
		protected var startTime:int;
		
// ***** CONSTRUCTOR *****

		public function AnimatedText()
		{
			super();
		}

// ***** Functions - Event handlers *****
		
		public function textUpdate(evt:Event):void
		{
			var s:String;
			var curTime:int = getTimer();
			curPosition = charsPerSecond / 1000 * (curTime - startTime);
			if (curPosition >= messageText.length) {
				curPosition = messageText.length;
				s = messageText;
				outputTextField.removeEventListener(
					Event.ENTER_FRAME, textUpdate);
				var evnt:Event = new Event(STRING_FINISHED_EVENT);
				this.dispatchEvent(evnt);
			} else {
				if (animationMode == SLOWTEXT) {
					s = messageText.substr(0, curPosition);
				} else {
					s = messageText.substr(0, curPosition/2);
					s += messageText.substr(-curPosition/2, curPosition/2);
				}
			}
			outputTextField.text = s;
		}
		
// ***** Functions - General control *****
		
		public function setText(tf:TextField,s:String,mode:int=0,cps:Number=10):void
		{
			messageText = s;
			charsPerSecond = cps;
			outputTextField = tf;
			animationMode = mode;
			curPosition = 0;
			startTime = getTimer();
			outputTextField.addEventListener(Event.ENTER_FRAME, textUpdate);
		}
	}
}