package com.blazinggames.gamejam.converse.starling
{
	import com.blazinggames.gamejam.converse.IResponse;
	
	import flash.geom.Rectangle;
	
	import starling.animation.Tween;
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.text.TextField;
	import starling.textures.Texture;
	
	public class BasicResponse extends Sprite implements IResponse
	{
// ***** VARIABLES *****
		private var _placement:Rectangle;
		private var _textOffest:Rectangle;
		private var _textures:Vector.<Texture>;
		private var _image:Image;
		private var _text:TextField;
		public var messageText:String = " ";
		public var showQuickly:Boolean;
		
		protected var _animatedText:AnimatedText;
		private var _tween:Tween;
		private var _resultCode:int;
		
		
		public function BasicResponse(placement:Rectangle, textOffset:Rectangle, textures:Vector.<Texture>)
		{
			super();
			_placement = placement;
			x = _placement.x;
			y = _placement.y;
			visible = false;
			_textures = textures;
			_image = new Image(_textures[0]);
			addChild(_image);
			_textOffest = textOffset;
			_text = new TextField(_textOffest.width, _textOffest.height, " ", "_sans", 18, 0x330033, true);
			_text.x = _textOffest.x;
			_text.y = _textOffest.y;
			addChild(_text);
			_animatedText = new AnimatedText();
			_tween = new Tween(this, 1);
		}
		
		public function showResponse(s:String, rCode:int, quickly:Boolean=false, dtype:int=0):void
		{
			_resultCode = rCode;
			visible = true;
			messageText = s;
			var texture:Texture = _textures[dtype];
			_image.texture = texture;
			if (quickly) {
				_image.scaleX = texture.width / _placement.width;
				_image.scaleY = texture.height / _placement.height;
				_text.text = s;
			} else {
				_image.scaleX = _placement.width / texture.width / 20;
				_image.scaleY = _placement.height / texture.height / 20;
				_image.x = _placement.width / 2;
				_image.y = _placement.height / 2;
				_tween.reset(_image , 1);
				_tween.animate("scaleX", _placement.width / texture.width);
				_tween.animate("scaleY", _placement.height / texture.height);
				_tween.moveTo(0,0);
				Starling.juggler.add(_tween);
				Starling.juggler.delayCall(startShowingText, 1);
				_text.text = " ";
			}
		}
		
		private function startShowingText():void
		{
			_animatedText.setText(_text,messageText,AnimatedText.EXPLODINGTEXT);
		}
		
		public function hideResponse():void
		{
			visible = false;
		}
		
		public function isShowing():Boolean
		{
			return visible;
		}
		
		public function getResultCode():int
		{
			return _resultCode;
		}
	}
}