package com.blazinggames.gamejam.data
{
	public class Itterator
	{
		private var _isItterating:Boolean;
		private var _list:Array;
		private var _removed:Array;
		private var _current:int;
		private var _indx:int;
		private var _keepCurrent:Boolean;
		
		public function Itterator(list:Array = null)
		{
			if (list != null)
				start(list);
			else {
				_isItterating = false;
				_list = null;
				_removed = null;
			}
		}
		
		public function start(list:Array):void
		{
			_list = list;
			_removed = new Array();
			_current = -1;
			_indx = 0;
			_keepCurrent = true;
			_isItterating = list.length > 0;
		}

		public function next():Object
		{
			if ( ! _isItterating)
				return null;
			if (_current < 0) { // first item
				_current = 0;
				return _list[0];
			} else {
				// condense array if items have been removed
				if (_current != _indx)
					_list[_indx] = _list[_current];
				++_current;
				if (_keepCurrent) {
					++_indx;
				} else {
					_removed.push(_list[_indx]);
					_keepCurrent = true;
				}
				// if not eol, return next item
				if (_current < _list.length)
					return _list[_current];
				// end of list fallthrough 
				_isItterating = false;
				if (_current != _indx)
					_list.splice(_indx);
				return null;
			}
		}
		
		public function remove():void
		{
			_keepCurrent = false;
		}
		
		public function getRemoved():Array
		{
			return _removed;
		}
		
		public function finish(keepRemaining:Boolean = true):void
		{
			if (keepRemaining) {
				while(next() != null) {};
			} else {
				while(next() != null)
					remove();
			}
		}
	}
}