package com.blazinggames.gamejam.tests
{
	import com.blazinggames.gamejam.data.TileMap;
	import com.blazinggames.gamejam.layers.starling.TileMapRenderer;
	
	import flash.geom.Rectangle;
	
	import starling.display.Sprite;
	import starling.textures.Texture;
	
	public class MapTestScreen extends Sprite
	{
		private var _tileMap:TileMap;
		private var _tileset:Vector.<Texture>
		private var _mapRenderer:TileMapRenderer;
		
		public function MapTestScreen()
		{
			super();
			performTextTest();
			_tileset = new Vector.<Texture>(4);
			_tileset[0] = Texture.fromColor(4,4,0xff000000);
			_tileset[3] = Texture.fromColor(4,4,0xFF880000);
			_mapRenderer = new TileMapRenderer(_tileMap, _tileset);
			_mapRenderer.setViewportSize(640,480);
			_mapRenderer.renderLayer(new Rectangle(0,0,20,16));
			addChild(_mapRenderer);
		}
		
// ***** METHODS - TileMap testing (text) *****
		
		private function dumpMap(message:String):void
		{
			var mapLine:String;
			
			trace("*");
			trace(message);
			
			for (var cntrY:int = 0; cntrY < _tileMap.height; ++cntrY) {
				mapLine = "";
				for (var cntrX:int = 0; cntrX < _tileMap.width; ++cntrX) {
					mapLine = mapLine + _tileMap.getTile(cntrX, cntrY);
				}
				trace(mapLine);
			}
		}
		private function performTextTest():void
		{
			_tileMap = new TileMap(32,32);
			dumpMap("Empty Map:");
			_tileMap.fillRect(0,0,4,4, 3);
			_tileMap.fillRect(4,4,4,4, 3);
			dumpMap("Starting a checkerboard pattern:");
			var checkerPattern:TileMap = _tileMap.createClip(0,0,8,8);
			_tileMap.pasteClip(checkerPattern, 8,0);
			dumpMap("Standard copy tested:");
			_tileMap.pasteClip(checkerPattern, 16,0,16,8);
			dumpMap("Horizontal wrapping copy tested:");
			_tileMap.pasteClip(checkerPattern, 0,8,8,24);
			dumpMap("Vertical wrapping copy tested:");
			_tileMap.pasteClip(checkerPattern, 8,8,24,24);
			dumpMap("H and V wrapping copy tested:");
			
		}
	}
}